diff --git a/content/renderer/pepper/video_decoder_shim.cc b/content/renderer/pepper/video_decoder_shim.cc
index ec176bf..c3cac28 100644
--- a/content/renderer/pepper/video_decoder_shim.cc
+++ b/content/renderer/pepper/video_decoder_shim.cc
@@ -679,12 +679,18 @@ void VideoDecoderShim::DecoderImpl::Initialize(
         new media::VpxVideoDecoder(base::ThreadTaskRunnerHandle::Get()));
   } else
 #endif
+
+#if !defined(MEDIA_DISABLE_FFMPEG) && !defined(DISABLE_FFMPEG_VIDEO_DECODERS)
   {
     scoped_ptr<media::FFmpegVideoDecoder> ffmpeg_video_decoder(
         new media::FFmpegVideoDecoder(base::ThreadTaskRunnerHandle::Get()));
     ffmpeg_video_decoder->set_decode_nalus(true);
     decoder_ = ffmpeg_video_decoder.Pass();
   }
+#elif defined(MEDIA_DISABLE_LIBVPX)
+  OnInitDone(false);
+  return;
+#endif
 
   // VpxVideoDecoder and FFmpegVideoDecoder support only one pending Decode()
   // request.
diff --git a/content/renderer/render_frame_impl.cc b/content/renderer/render_frame_impl.cc
index 2e7d77a..d479ce9 100644
--- a/content/renderer/render_frame_impl.cc
+++ b/content/renderer/render_frame_impl.cc
@@ -188,6 +188,10 @@
 #include "media/renderers/default_renderer_factory.h"
 #endif
 
+#if defined(USE_GSTREAMER)
+#include "media/gstreamer/webmediaplayer_gstreamer.h"
+#endif
+
 #if defined(ENABLE_WEBVR)
 #include "content/renderer/vr/vr_dispatcher.h"
 #endif
@@ -1970,6 +1974,35 @@ blink::WebMediaPlayer* RenderFrameImpl::createMediaPlayer(
   }
 #endif  // defined(VIDEO_HOLE)
 
+#if defined(USE_GSTREAMER)
+  // TODO: Fix kEnableGStreamerMediaBackend.
+  if (1 ||
+      base::CommandLine::ForCurrentProcess()->HasSwitch(
+          switches::kEnableGStreamerMediaBackend)) {
+
+    if (!content::RenderThreadImpl::current()->GetMediaChannel()) {
+      content::RenderThreadImpl::current()->EstablishMediaChannelSync();
+    }
+
+    if (!content::RenderThreadImpl::current()->GetMediaChannel()) {
+      LOG(ERROR) << "Cannot create WebMediaPlayerGStreamer because there is no media channel";
+      return NULL;
+    }
+
+    DVLOG(1) << __FUNCTION__ << "(Create WebMediaPlayerGStreamer)";
+    blink::WebMediaPlayer* player_gst = new media::WebMediaPlayerGStreamer(
+          frame, client, weak_factory_.GetWeakPtr(), GetCdmFactory(),
+          GetMediaPermission(), initial_cdm, new RenderMediaLog());
+
+    if (!player_gst) {
+        LOG(ERROR) << "Failed to create WebMediaPlayerGStreamer";
+        return NULL;
+    }
+
+    return player_gst;
+  }
+#endif  // defined(USE_GSTREAMER)
+
   blink::WebMediaStream web_stream(
       blink::WebMediaStreamRegistry::lookupMediaStreamDescriptor(url));
   if (!web_stream.isNull())
diff --git a/content/renderer/render_thread_impl.cc b/content/renderer/render_thread_impl.cc
index 8a155a4..957a864 100644
--- a/content/renderer/render_thread_impl.cc
+++ b/content/renderer/render_thread_impl.cc
@@ -67,6 +67,10 @@
 #include "content/common/gpu/gpu_process_launch_causes.h"
 #include "content/common/render_frame_setup.mojom.h"
 #include "content/common/resource_messages.h"
+#if defined(USE_GSTREAMER)
+#include "content/common/media/media_channel_host.h"
+#include "content/common/media/media_messages.h"
+#endif
 #include "content/common/view_messages.h"
 #include "content/common/worker_messages.h"
 #include "content/public/common/content_constants.h"
@@ -880,7 +884,10 @@ void RenderThreadImpl::Shutdown() {
 
   if (gpu_channel_.get())
     gpu_channel_->DestroyChannel();
-
+#if defined(USE_GSTREAMER)
+  if (media_channel_.get())
+    media_channel_->DestroyChannel();
+#endif
   // TODO(port)
 #if defined(OS_WIN)
   // Clean up plugin channels before this thread goes away.
@@ -1713,7 +1720,50 @@ GpuChannelHost* RenderThreadImpl::EstablishGpuChannelSync(
                              gpu_memory_buffer_manager());
   return gpu_channel_.get();
 }
+#if defined(USE_GSTREAMER)
+MediaChannelHost* RenderThreadImpl::EstablishMediaChannelSync(
+    CauseForMediaLaunch cause_for_media_launch) {
+  if (media_channel_.get()) {
+    // Do nothing if we already have a Media channel or are already
+    // establishing one.
+    if (!media_channel_->IsLost())
+      return media_channel_.get();
+
+    // Recreate the channel if it has been lost.
+    media_channel_->DestroyChannel();
+    media_channel_ = NULL;
+  }
+
+  // Ask the browser for the channel name.
+  int client_id = 0;
+  IPC::ChannelHandle channel_handle;
+
+  if (!Send(new MediaHostMsg_EstablishMediaChannel(
+          cause_for_media_launch, &client_id, &channel_handle)) ||
+#if defined(OS_POSIX)
+      channel_handle.socket.fd == -1 ||
+#endif
+      channel_handle.name.empty()) {
+    // Otherwise cancel the connection.
+    return NULL;
+  }
+
+  media_channel_ = content::MediaChannelHost::Create(
+      channel_handle, content::ChildProcess::current()->GetShutDownEvent());
+
+  return media_channel_.get();
+}
+
+MediaChannelHost* RenderThreadImpl::GetMediaChannel() {
+  if (!media_channel_.get())
+    return NULL;
 
+  if (media_channel_->IsLost())
+    return NULL;
+
+  return media_channel_.get();
+}
+#endif
 blink::WebMediaStreamCenter* RenderThreadImpl::CreateMediaStreamCenter(
     blink::WebMediaStreamCenterClient* client) {
 #if defined(OS_ANDROID)
diff --git a/content/renderer/render_thread_impl.h b/content/renderer/render_thread_impl.h
index a6343d1..603a332 100644
--- a/content/renderer/render_thread_impl.h
+++ b/content/renderer/render_thread_impl.h
@@ -23,6 +23,10 @@
 #include "content/common/frame_replication_state.h"
 #include "content/common/gpu/client/gpu_channel_host.h"
 #include "content/common/gpu/gpu_result_codes.h"
+#if defined(USE_GSTREAMER)
+#include "content/common/media/media_channel_host.h"
+#include "content/common/media/media_process_launch_causes.h"
+#endif
 #include "content/public/renderer/render_thread.h"
 #include "content/renderer/gpu/compositor_dependencies.h"
 #include "net/base/network_change_notifier.h"
@@ -94,6 +98,7 @@ class DevToolsAgentFilter;
 class DomStorageDispatcher;
 class EmbeddedWorkerDispatcher;
 class GpuChannelHost;
+class MediaChannelHost;
 class IndexedDBDispatcher;
 class InputHandlerManager;
 class MediaStreamCenter;
@@ -212,6 +217,15 @@ class CONTENT_EXPORT RenderThreadImpl
   // time this routine returns.
   GpuChannelHost* EstablishGpuChannelSync(CauseForGpuLaunch);
 
+#if defined(USE_GSTREAMER)
+  // Synchronously establish a channel to the media process if not previously
+  // established or if it has been lost or get the current channel.
+  MediaChannelHost* EstablishMediaChannelSync(
+      CauseForMediaLaunch = CAUSE_FOR_MEDIA_LAUNCH_RENDERER);
+
+  // Get media channel if it is created and not lost.
+  MediaChannelHost* GetMediaChannel();
+#endif
 
   // This method modifies how the next message is sent.  Normally, when sending
   // a synchronous message that runs a nested message loop, we need to suspend
@@ -542,7 +556,10 @@ class CONTENT_EXPORT RenderThreadImpl
 
   // The channel from the renderer process to the GPU process.
   scoped_refptr<GpuChannelHost> gpu_channel_;
-
+#if defined(USE_GSTREAMER)
+  // The channel from the renderer process to the media process.
+  scoped_refptr<content::MediaChannelHost> media_channel_;
+#endif
   // Cache of variables that are needed on the compositor thread by
   // GpuChannelHostFactory methods.
   scoped_refptr<base::SingleThreadTaskRunner> io_thread_task_runner_;
diff --git a/content/shell/app/shell_crash_reporter_client.cc b/content/shell/app/shell_crash_reporter_client.cc
index fab0e90..215dda3 100644
--- a/content/shell/app/shell_crash_reporter_client.cc
+++ b/content/shell/app/shell_crash_reporter_client.cc
@@ -68,7 +68,12 @@ bool ShellCrashReporterClient::EnableBreakpadForProcess(
          process_type == switches::kPluginProcess ||
          process_type == switches::kPpapiPluginProcess ||
          process_type == switches::kZygoteProcess ||
+#if defined(USE_GSTREAMER)
+         process_type == switches::kGpuProcess ||
+         process_type == switches::kMediaProcess;
+#else
          process_type == switches::kGpuProcess;
+#endif
 }
 
 }  // namespace content
diff --git a/content/shell/browser/shell_content_browser_client.cc b/content/shell/browser/shell_content_browser_client.cc
index fd8a49c..404aa60 100644
--- a/content/shell/browser/shell_content_browser_client.cc
+++ b/content/shell/browser/shell_content_browser_client.cc
@@ -114,6 +114,15 @@ int GetCrashSignalFD(const base::CommandLine& command_line) {
     return crash_handler->GetDeathSignalSocket();
   }
 
+#if defined(USE_GSTREAMER)
+  if (process_type == switches::kMediaProcess) {
+    static breakpad::CrashHandlerHostLinux* crash_handler = NULL;
+    if (!crash_handler)
+      crash_handler = CreateCrashHandlerHost(process_type);
+    return crash_handler->GetDeathSignalSocket();
+  }
+#endif
+
   return -1;
 }
 #endif  // defined(OS_POSIX) && !defined(OS_MACOSX) && !defined(OS_ANDROID)
diff --git a/gpu/command_buffer/service/feature_info.cc b/gpu/command_buffer/service/feature_info.cc
index c747383..41714d5 100644
--- a/gpu/command_buffer/service/feature_info.cc
+++ b/gpu/command_buffer/service/feature_info.cc
@@ -239,6 +239,20 @@ bool IsGL_REDSupportedOnFBOs() {
   GLubyte data[1] = {0};
   glTexImage2D(GL_TEXTURE_2D, 0, GL_RED_EXT, 1, 1, 0, GL_RED_EXT,
                GL_UNSIGNED_BYTE, data);
+
+#if defined(USE_GSTREAMER)
+  // Workaround glCheckFramebufferStatusEXT that may
+  // returns true even if glTexImage2D failed.
+  GLenum gl_error = glGetError();
+  if (gl_error != GL_NO_ERROR) {
+    LOG(INFO) << "RED not supported on FBO";
+    glDeleteTextures(1, &textureId);
+    glBindFramebufferEXT(GL_FRAMEBUFFER, static_cast<GLuint>(fb_binding));
+    glBindTexture(GL_TEXTURE_2D, static_cast<GLuint>(tex_binding));
+    return false;
+  }
+#endif
+
   GLuint textureFBOID = 0;
   glGenFramebuffersEXT(1, &textureFBOID);
   glBindFramebufferEXT(GL_FRAMEBUFFER, textureFBOID);
diff --git a/gpu/config/gpu_blacklist.cc b/gpu/config/gpu_blacklist.cc
index a359123..f554f1b 100644
--- a/gpu/config/gpu_blacklist.cc
+++ b/gpu/config/gpu_blacklist.cc
@@ -20,8 +20,11 @@ GpuBlacklist* GpuBlacklist::Create() {
   GpuBlacklist* list = new GpuBlacklist();
   list->AddSupportedFeature("accelerated_2d_canvas",
                             GPU_FEATURE_TYPE_ACCELERATED_2D_CANVAS);
+#if !defined(USE_GSTREAMER)
+  // Do not black list gpu compositing for GStreamer backend (GstGL).
   list->AddSupportedFeature("gpu_compositing",
                             GPU_FEATURE_TYPE_GPU_COMPOSITING);
+#endif
   list->AddSupportedFeature("webgl",
                             GPU_FEATURE_TYPE_WEBGL);
   list->AddSupportedFeature("flash_3d",
diff --git a/ipc/ipc_message_start.h b/ipc/ipc_message_start.h
index bd47f20..a7ea118 100644
--- a/ipc/ipc_message_start.h
+++ b/ipc/ipc_message_start.h
@@ -70,6 +70,9 @@ enum IPCMessageStart {
   MetroViewerMsgStart,
   CCMsgStart,
   MediaPlayerMsgStart,
+#if defined(USE_GSTREAMER)
+  MediaMsgStart,
+#endif
   TracingMsgStart,
   PeerConnectionTrackerMsgStart,
   VisitedLinkMsgStart,
diff --git a/media/base/cdm_key_information.h b/media/base/cdm_key_information.h
index 4f9d8e0..ca4f044 100644
--- a/media/base/cdm_key_information.h
+++ b/media/base/cdm_key_information.h
@@ -28,6 +28,9 @@ struct MEDIA_EXPORT CdmKeyInformation {
   ~CdmKeyInformation();
 
   std::vector<uint8> key_id;
+#if defined(USE_GSTREAMER)
+  std::string key;
+#endif
   KeyStatus status;
   uint32 system_code;
 };
diff --git a/media/base/media_switches.cc b/media/base/media_switches.cc
index 0b01546..916a700 100644
--- a/media/base/media_switches.cc
+++ b/media/base/media_switches.cc
@@ -4,6 +4,10 @@
 
 #include "media/base/media_switches.h"
 
+#if defined(USE_GSTREAMER)
+#include "base/basictypes.h"
+#endif
+
 namespace switches {
 
 // Allow users to specify a custom buffer size for debugging purpose.
@@ -114,6 +118,16 @@ const char kEnableInbandTextTracks[] = "enable-inband-text-tracks";
 const char kRequireAudioHardwareForTesting[] =
     "require-audio-hardware-for-testing";
 
+#if defined(USE_GSTREAMER)
+const char kEnableMediaDebugging[] = "enable-media-debugging";
+
+const char* kMediaSwitches[] = {
+    kEnableMediaDebugging,
+};
+
+const int kNumMediaSwitches = arraysize(kMediaSwitches);
+#endif
+
 // Allows clients to override the threshold for when the media renderer will
 // declare the underflow state for the video stream when audio is present.
 // TODO(dalecurtis): Remove once experiments for http://crbug.com/470940 finish.
diff --git a/media/base/media_switches.h b/media/base/media_switches.h
index c8c8488..790babb 100644
--- a/media/base/media_switches.h
+++ b/media/base/media_switches.h
@@ -47,6 +47,11 @@ MEDIA_EXPORT extern const char kWaveOutBuffers[];
 MEDIA_EXPORT extern const char kUseCras[];
 #endif
 
+#if defined(USE_GSTREAMER)
+MEDIA_EXPORT extern const char* kMediaSwitches[];
+MEDIA_EXPORT extern const int kNumMediaSwitches;
+#endif
+
 MEDIA_EXPORT extern const char kEnableAudioHangMonitor[];
 
 MEDIA_EXPORT extern const char kUseFakeDeviceForMediaStream[];
diff --git a/media/base/mime_util.cc b/media/base/mime_util.cc
index 535837c..1e7f63e 100644
--- a/media/base/mime_util.cc
+++ b/media/base/mime_util.cc
@@ -154,7 +154,7 @@ static const char* const common_media_types[] = {
   "audio/wav",
   "audio/x-wav",
 
-#if defined(OS_ANDROID)
+#if defined(OS_ANDROID) || defined(USE_GSTREAMER)
   // HLS.
   "application/vnd.apple.mpegurl",
   "application/x-mpegurl",
diff --git a/media/blink/buffered_data_source.cc b/media/blink/buffered_data_source.cc
index d5f32b1..1bf808a 100644
--- a/media/blink/buffered_data_source.cc
+++ b/media/blink/buffered_data_source.cc
@@ -136,13 +136,28 @@ BufferedResourceLoader* BufferedDataSource::CreateResourceLoader(
                                     media_log_.get());
 }
 
+#if defined(USE_GSTREAMER)
+void BufferedDataSource::Initialize(const InitializeCB& init_cb,
+                                    blink::WebURLLoader* url_loader,
+                                    const blink::WebString& referrer,
+                                    blink::WebReferrerPolicy referrer_policy) {
+#else
 void BufferedDataSource::Initialize(const InitializeCB& init_cb) {
+#endif
+
   DCHECK(render_task_runner_->BelongsToCurrentThread());
   DCHECK(!init_cb.is_null());
   DCHECK(!loader_.get());
 
   init_cb_ = init_cb;
 
+#if defined(USE_GSTREAMER)
+  // TODO: improve this depending if we keep using BufferedDataSource.
+  url_loader_ = url_loader;
+  referrer_ = referrer;
+  referrer_policy_ = referrer_policy;
+#endif
+
   if (url_.SchemeIsHTTPOrHTTPS()) {
     // Do an unbounded range request starting at the beginning.  If the server
     // responds with 200 instead of 206 we'll fall back into a streaming mode.
@@ -159,8 +174,14 @@ void BufferedDataSource::Initialize(const InitializeCB& init_cb) {
   loader_->Start(
       base::Bind(&BufferedDataSource::StartCallback, weak_this),
       base::Bind(&BufferedDataSource::LoadingStateChangedCallback, weak_this),
-      base::Bind(&BufferedDataSource::ProgressCallback, weak_this),
+      base::Bind(&BufferedDataSource::ProgressCallback, weak_this)
+#if defined(USE_GSTREAMER)
+          ,
+      frame_, url_loader_, referrer_, referrer_policy_);
+#else
+          ,
       frame_);
+#endif
 }
 
 void BufferedDataSource::SetPreload(Preload preload) {
@@ -463,7 +484,11 @@ void BufferedDataSource::ReadCallback(
           base::Bind(&BufferedDataSource::LoadingStateChangedCallback,
                      weak_this),
           base::Bind(&BufferedDataSource::ProgressCallback, weak_this),
+#if defined(USE_GSTREAMER)
+          frame_, url_loader_, referrer_, referrer_policy_);
+#else
           frame_);
+#endif
       return;
     }
 
diff --git a/media/blink/buffered_data_source.h b/media/blink/buffered_data_source.h
index 32f1481..ad2f347 100644
--- a/media/blink/buffered_data_source.h
+++ b/media/blink/buffered_data_source.h
@@ -18,6 +18,11 @@
 #include "media/blink/buffered_resource_loader.h"
 #include "url/gurl.h"
 
+#if defined(USE_GSTREAMER)
+#include "third_party/WebKit/public/platform/WebReferrerPolicy.h"
+#include "third_party/WebKit/public/platform/WebURLLoader.h"
+#endif
+
 namespace base {
 class SingleThreadTaskRunner;
 }
@@ -77,7 +82,16 @@ class MEDIA_EXPORT BufferedDataSource : public DataSource {
   //
   // Method called on the render thread.
   typedef base::Callback<void(bool)> InitializeCB;
+
+#if defined(USE_GSTREAMER)
+  void Initialize(const InitializeCB& init_cb,
+                  blink::WebURLLoader* url_loader = nullptr,
+                  const blink::WebString& referrer = blink::WebString(),
+                  blink::WebReferrerPolicy referrer_policy =
+                      blink::WebReferrerPolicyDefault);
+#else
   void Initialize(const InitializeCB& init_cb);
+#endif
 
   // Adjusts the buffering algorithm based on the given preload value.
   void SetPreload(Preload preload);
@@ -238,6 +252,12 @@ class MEDIA_EXPORT BufferedDataSource : public DataSource {
 
   DownloadingCB downloading_cb_;
 
+#if defined(USE_GSTREAMER)
+  blink::WebURLLoader* url_loader_;
+  blink::WebString referrer_;
+  blink::WebReferrerPolicy referrer_policy_;
+#endif
+
   // Disallow rebinding WeakReference ownership to a different thread by keeping
   // a persistent reference. This avoids problems with the thread-safety of
   // reaching into this class from multiple threads to attain a WeakPtr.
diff --git a/media/blink/buffered_resource_loader.cc b/media/blink/buffered_resource_loader.cc
index 51ec8fe..3776f9e 100644
--- a/media/blink/buffered_resource_loader.cc
+++ b/media/blink/buffered_resource_loader.cc
@@ -19,6 +19,12 @@
 #include "third_party/WebKit/public/web/WebKit.h"
 #include "third_party/WebKit/public/web/WebURLLoaderOptions.h"
 
+#if defined(USE_GSTREAMER)
+#include "content/child/web_url_loader_impl.h"
+#include "content/public/child/child_thread.h"
+#include "public/platform/Platform.h"
+#endif
+
 using blink::WebFrame;
 using blink::WebString;
 using blink::WebURLError;
@@ -134,11 +140,18 @@ BufferedResourceLoader::BufferedResourceLoader(
 
 BufferedResourceLoader::~BufferedResourceLoader() {}
 
-void BufferedResourceLoader::Start(
-    const StartCB& start_cb,
-    const LoadingStateChangedCB& loading_cb,
-    const ProgressCB& progress_cb,
-    WebFrame* frame) {
+void BufferedResourceLoader::Start(const StartCB& start_cb,
+                                   const LoadingStateChangedCB& loading_cb,
+                                   const ProgressCB& progress_cb,
+                                   WebFrame* frame
+#if defined(USE_GSTREAMER)
+                                   ,
+                                   WebURLLoader* url_loader,
+                                   const WebString& referrer,
+                                   blink::WebReferrerPolicy referrer_policy) {
+#else
+                                   ) {
+#endif
   // Make sure we have not started.
   DCHECK(start_cb_.is_null());
   DCHECK(loading_cb_.is_null());
@@ -146,7 +159,9 @@ void BufferedResourceLoader::Start(
   DCHECK(!start_cb.is_null());
   DCHECK(!loading_cb.is_null());
   DCHECK(!progress_cb.is_null());
+#if !defined(USE_GSTREAMER)
   CHECK(frame);
+#endif
 
   start_cb_ = start_cb;
   loading_cb_ = loading_cb;
@@ -170,7 +185,20 @@ void BufferedResourceLoader::Start(
             first_byte_position_, last_byte_position_).GetHeaderValue()));
   }
 
+#if defined(USE_GSTREAMER)
+  if (url_loader) {
+    // TODO: Add API to BufferedDataSource to allow to set
+    // extra headers and referrer on the request.
+    // Depends if we keep using BufferedDataSource.
+    request.setHTTPReferrer(referrer, referrer_policy);
+    if (url_.host() == "movies.apple.com" ||
+        url_.host() == "trailers.apple.com")
+      request.setHTTPHeaderField("User-Agent", "Quicktime/7.6.6");
+  } else
+    frame->setReferrerForRequest(request, blink::WebURL());
+#else
   frame->setReferrerForRequest(request, blink::WebURL());
+#endif
 
   // Disable compression, compression for audio/video doesn't make sense...
   request.setHTTPHeaderField(
@@ -196,7 +224,16 @@ void BufferedResourceLoader::Start(
       if (cors_mode_ == kUseCredentials)
         options.allowCredentials = true;
     }
+
+#if defined(USE_GSTREAMER)
+    // TODO: improve this depending if we keep using BufferedDataSource.
+    if (url_loader)
+      loader.reset(url_loader);
+    else
+      loader.reset(frame->createAssociatedURLLoader(options));
+#else
     loader.reset(frame->createAssociatedURLLoader(options));
+#endif
   }
 
   // Start the resource loading.
diff --git a/media/blink/buffered_resource_loader.h b/media/blink/buffered_resource_loader.h
index cb02720..032e534 100644
--- a/media/blink/buffered_resource_loader.h
+++ b/media/blink/buffered_resource_loader.h
@@ -18,6 +18,10 @@
 #include "third_party/WebKit/public/web/WebFrame.h"
 #include "url/gurl.h"
 
+#if defined(USE_GSTREAMER)
+#include "third_party/WebKit/public/platform/WebReferrerPolicy.h"
+#endif
+
 namespace media {
 class MediaLog;
 class SeekableBuffer;
@@ -99,7 +103,15 @@ class MEDIA_EXPORT BufferedResourceLoader
   void Start(const StartCB& start_cb,
              const LoadingStateChangedCB& loading_cb,
              const ProgressCB& progress_cb,
-             blink::WebFrame* frame);
+             blink::WebFrame* frame
+#if defined(USE_GSTREAMER)
+             ,
+             blink::WebURLLoader* url_loader,
+             const blink::WebString& referrer,
+             blink::WebReferrerPolicy referrer_policy);
+#else
+             );
+#endif
 
   // Stops everything associated with this loader, including active URL loads
   // and pending callbacks.
diff --git a/media/blink/encrypted_media_player_support.cc b/media/blink/encrypted_media_player_support.cc
index 39ae48f..ffbf46c 100644
--- a/media/blink/encrypted_media_player_support.cc
+++ b/media/blink/encrypted_media_player_support.cc
@@ -117,12 +117,22 @@ EncryptedMediaPlayerSupport::EncryptedMediaPlayerSupport(
     CdmFactory* cdm_factory,
     blink::WebMediaPlayerClient* client,
     MediaPermission* media_permission,
+#if defined(USE_GSTREAMER)
+    const CdmContextReadyCB& cdm_context_ready_cb,
+    const CdmContextKeysReadyCB& cdm_context_keys_ready_cb)
+#else
     const CdmContextReadyCB& cdm_context_ready_cb)
+#endif
     : cdm_factory_(cdm_factory),
       client_(client),
       media_permission_(media_permission),
       init_data_type_(EmeInitDataType::UNKNOWN),
+#if defined(USE_GSTREAMER)
+      cdm_context_ready_cb_(cdm_context_ready_cb),
+      cdm_context_keys_ready_cb_(cdm_context_keys_ready_cb) {
+#else
       cdm_context_ready_cb_(cdm_context_ready_cb) {
+#endif
 }
 
 EncryptedMediaPlayerSupport::~EncryptedMediaPlayerSupport() {
@@ -170,8 +180,14 @@ EncryptedMediaPlayerSupport::GenerateKeyRequestInternal(
         BIND_TO_RENDER_LOOP(&EncryptedMediaPlayerSupport::OnKeyMessage)));
 
     GURL security_origin(frame->document().securityOrigin().toString());
+#if defined(USE_GSTREAMER)
+    proxy_decryptor_->CreateCdm(cdm_factory_, key_system, security_origin,
+                                cdm_context_ready_cb_,
+                                cdm_context_keys_ready_cb_);
+#else
     proxy_decryptor_->CreateCdm(cdm_factory_, key_system, security_origin,
                                 cdm_context_ready_cb_);
+#endif
     current_key_system_ = key_system;
   }
 
diff --git a/media/blink/encrypted_media_player_support.h b/media/blink/encrypted_media_player_support.h
index 6ddec23..a8ecd27 100644
--- a/media/blink/encrypted_media_player_support.h
+++ b/media/blink/encrypted_media_player_support.h
@@ -38,12 +38,22 @@ class EncryptedMediaPlayerSupport
     : public base::SupportsWeakPtr<EncryptedMediaPlayerSupport> {
  public:
   using CdmContextReadyCB = ProxyDecryptor::CdmContextReadyCB;
+#if defined(USE_GSTREAMER)
+  using CdmContextKeysReadyCB = ProxyDecryptor::CdmContextKeysReadyCB;
+#endif
 
   // |cdm_context_ready_cb| is called when the CDM instance creation completes.
-  EncryptedMediaPlayerSupport(CdmFactory* cdm_factory,
-                              blink::WebMediaPlayerClient* client,
-                              MediaPermission* media_permission,
-                              const CdmContextReadyCB& cdm_context_ready_cb);
+  EncryptedMediaPlayerSupport(
+      CdmFactory* cdm_factory,
+      blink::WebMediaPlayerClient* client,
+      MediaPermission* media_permission,
+#if defined(USE_GSTREAMER)
+      const CdmContextReadyCB& cdm_context_ready_cb,
+      const CdmContextKeysReadyCB& cdm_context_keys_ready_cb =
+          base::Bind(&media::IgnoreCdmContextKeysReady));
+#else
+      const CdmContextReadyCB& cdm_context_ready_cb);
+#endif
   ~EncryptedMediaPlayerSupport();
 
   blink::WebMediaPlayer::MediaKeyException GenerateKeyRequest(
@@ -108,6 +118,9 @@ class EncryptedMediaPlayerSupport
   EmeInitDataType init_data_type_;
 
   CdmContextReadyCB cdm_context_ready_cb_;
+#if defined(USE_GSTREAMER)
+  CdmContextKeysReadyCB cdm_context_keys_ready_cb_;
+#endif
 
   // Manages decryption keys and decrypts encrypted frames.
   scoped_ptr<ProxyDecryptor> proxy_decryptor_;
diff --git a/media/blink/webmediaplayer_impl.cc b/media/blink/webmediaplayer_impl.cc
index aa7b073..15105c8 100644
--- a/media/blink/webmediaplayer_impl.cc
+++ b/media/blink/webmediaplayer_impl.cc
@@ -903,8 +903,12 @@ void WebMediaPlayerImpl::StartPipeline() {
     DCHECK(!chunk_demuxer_);
     DCHECK(data_source_);
 
+#if !defined(MEDIA_DISABLE_FFMPEG)
     demuxer_.reset(new FFmpegDemuxer(media_task_runner_, data_source_.get(),
                                      encrypted_media_init_data_cb, media_log_));
+#else
+    OnPipelineError(PipelineStatus::DEMUXER_ERROR_COULD_NOT_OPEN);
+#endif
   } else {
     DCHECK(!chunk_demuxer_);
     DCHECK(!data_source_);
diff --git a/media/cdm/aes_decryptor.cc b/media/cdm/aes_decryptor.cc
index 6bc7121..5db71fb 100644
--- a/media/cdm/aes_decryptor.cc
+++ b/media/cdm/aes_decryptor.cc
@@ -274,7 +274,7 @@ void AesDecryptor::CreateSessionAndGenerateRequest(
         keys.push_back(init_data);
         break;
       case EmeInitDataType::CENC:
-#if defined(USE_PROPRIETARY_CODECS)
+#if defined(USE_PROPRIETARY_CODECS) || defined(USE_GSTREAMER)
         // |init_data| is a set of 0 or more concatenated 'pssh' boxes.
         if (!GetKeyIdsForCommonSystemId(init_data, &keys)) {
           promise->reject(NOT_SUPPORTED_ERROR, 0,
@@ -389,6 +389,10 @@ void AesDecryptor::UpdateSession(const std::string& session_id,
       if (item.second->Contains(session_id)) {
         scoped_ptr<CdmKeyInformation> key_info(new CdmKeyInformation);
         key_info->key_id.assign(item.first.begin(), item.first.end());
+#if defined(USE_GSTREAMER)
+        item.second->LatestDecryptionKey()->decryption_key()->GetRawKey(
+            &key_info->key);
+#endif
         key_info->status = CdmKeyInformation::USABLE;
         key_info->system_code = 0;
         keys_info.push_back(key_info.release());
diff --git a/media/cdm/cenc_utils.cc b/media/cdm/cenc_utils.cc
index ec7544e..7ed7dae 100644
--- a/media/cdm/cenc_utils.cc
+++ b/media/cdm/cenc_utils.cc
@@ -21,6 +21,12 @@ const uint8_t kCencCommonSystemId[] = {0x10, 0x77, 0xef, 0xec, 0xc0, 0xb2,
                                        0x4d, 0x02, 0xac, 0xe3, 0x3c, 0x1e,
                                        0x52, 0xe2, 0xfb, 0x4b};
 
+#if defined(USE_GSTREAMER)
+const uint8_t kLegacyCencCommonSystemId[] = {0x58, 0x14, 0x7e, 0xc8, 0x04, 0x23,
+                                             0x46, 0x59, 0x92, 0xe6, 0xf5, 0x2c,
+                                             0x5c, 0xe8, 0xc3, 0xcc};
+#endif
+
 // Returns true if |input| contains only 1 or more valid 'pssh' boxes, false
 // otherwise. |pssh_boxes| is updated as the set of parsed 'pssh' boxes.
 // Note: All boxes in |input| must be 'pssh' boxes. However, if they can't be
@@ -89,10 +95,24 @@ bool GetKeyIdsForCommonSystemId(const std::vector<uint8_t>& pssh_boxes,
   std::vector<uint8_t> common_system_id(
       kCencCommonSystemId,
       kCencCommonSystemId + arraysize(kCencCommonSystemId));
+#if defined(USE_GSTREAMER)  // Some tests still use legacy cenc id.
+  std::vector<uint8_t> legacy_common_system_id(
+      kLegacyCencCommonSystemId,
+      kLegacyCencCommonSystemId + arraysize(kLegacyCencCommonSystemId));
+#endif
   for (const auto& child : children) {
+#if defined(USE_GSTREAMER)
+    if (child.system_id == common_system_id ||
+        child.system_id == legacy_common_system_id) {
+#else
     if (child.system_id == common_system_id) {
+#endif
       key_ids->assign(child.key_ids.begin(), child.key_ids.end());
+#if defined(USE_GSTREAMER)
+      return true;  // pssh for common decryption might not have key ids at all.
+#else
       return key_ids->size() > 0;
+#endif
     }
   }
 
diff --git a/media/cdm/proxy_decryptor.cc b/media/cdm/proxy_decryptor.cc
index a568211..afdbd5e 100644
--- a/media/cdm/proxy_decryptor.cc
+++ b/media/cdm/proxy_decryptor.cc
@@ -61,10 +61,22 @@ ProxyDecryptor::~ProxyDecryptor() {
   media_keys_.reset();
 }
 
-void ProxyDecryptor::CreateCdm(CdmFactory* cdm_factory,
-                               const std::string& key_system,
-                               const GURL& security_origin,
-                               const CdmContextReadyCB& cdm_context_ready_cb) {
+#if defined(USE_GSTREAMER)
+void IgnoreCdmContextKeysReady(const std::string& session_id,
+                               bool has_additional_usable_key,
+                               CdmKeysInfo keys_info) {}
+#endif
+
+void ProxyDecryptor::CreateCdm(
+    CdmFactory* cdm_factory,
+    const std::string& key_system,
+    const GURL& security_origin,
+#if defined(USE_GSTREAMER)
+    const CdmContextReadyCB& cdm_context_ready_cb,
+    const CdmContextKeysReadyCB& cdm_context_keys_ready_cb) {
+#else
+    const CdmContextReadyCB& cdm_context_ready_cb) {
+#endif
   DVLOG(1) << __FUNCTION__ << ": key_system = " << key_system;
   DCHECK(!is_creating_cdm_);
   DCHECK(!media_keys_);
@@ -79,6 +91,10 @@ void ProxyDecryptor::CreateCdm(CdmFactory* cdm_factory,
 
   is_creating_cdm_ = true;
 
+#if defined(USE_GSTREAMER)
+  cdm_context_keys_ready_cb_ = cdm_context_keys_ready_cb;
+#endif
+
   base::WeakPtr<ProxyDecryptor> weak_this = weak_ptr_factory_.GetWeakPtr();
   cdm_factory->Create(
       key_system, security_origin, cdm_config,
@@ -326,6 +342,10 @@ void ProxyDecryptor::OnSessionKeysChange(const std::string& session_id,
                                          bool has_additional_usable_key,
                                          CdmKeysInfo keys_info) {
   // EME v0.1b doesn't support this event.
+#if defined(USE_GSTREAMER)
+  cdm_context_keys_ready_cb_.Run(session_id, has_additional_usable_key,
+                                 keys_info.Pass());
+#endif
 }
 
 void ProxyDecryptor::OnSessionExpirationUpdate(
